/* **************************************************************************
 * This file is part of Timothy_benchmark
 *
 * Copyright (c) 2014/15 Maciej Cytowski
 * Copyright (c) 2014/15 ICM, University of Warsaw, Poland
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * *************************************************************************/
#define N_LEVELS 30
#define ROOT_LEVEL N_LEVELS-1
#define MAXVALUE powf(2,ROOT_LEVEL)

typedef struct octNode_t {
  unsigned int xcode;
  unsigned int ycode;
  unsigned int zcode;
  unsigned int xlimit;
  unsigned int ylimit;
  unsigned int zlimit;
  unsigned int level;
  int64_t father;
  int64_t child[8];
  int data;
} octNode;

octNode MIC_ATTR *octree;
int64_t octSize;

typedef struct uintVector3d_t {
  unsigned int x;
  unsigned int y;
  unsigned int z;
} uintVector3d;

typedef struct doubleVector3d_t {
  double x;
  double y;
  double z;
} doubleVector3d;

typedef struct octHeap_t {
  int size;
  int count;
  int *data;
} octHeap;

/* properties of the affine transformation */
doubleVector3d MIC_ATTR affShift;
double MIC_ATTR affScale;
int64_t root;

uintVector3d *locCode;

double octBuild(cell_data *cells,int64_t number_of_cells);
void octFree();

